﻿
assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALDurability")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["durabilityleader"] = true,
	["durability"] = true,
	["Durability"] = true,
	["Leader/Durability"] = true,
	["Options for durability checks."] = true,
	["check"] = true,
	["Perform durability check"] = true,
	["Check the raid's durability."] = true,
	["Name"] = true,
	["Percent"] = true,
	["Broken"] = true,
	["Perc"] = true,
	["Close"] = true,
	["Refresh"] = true,
} end )

L:RegisterTranslations("koKR", function() return {
	["Durability"] = "내구도",
	["Leader/Durability"] = "공격대장/내구도",
	["Options for durability checks."] = "내구도 확인 설정",
	["check"] = "체크",
	["Perform durability check"] = "내구도 확인 실시",
	["Check the raid's durability."] = "공격대원의 아이템의 내구도를 확인합니다",
	["Name"] = "이름",
	["Percent"] = "백분률",
	["Broken"] = "파손",
	["Perc"] = "백분률",
	["Close"] = "닫기",
	["Refresh"] = "갱신",
} end )

L:RegisterTranslations("zhCN", function() return {
	["durabilityleader"] = "durabilityleader",
	["durability"] = "装备耐久度",
	["Durability"] = "装备耐久度",
	["Leader/Durability"] = "Leader/Durability",
	["Options for durability checks."] = "耐久度选项",
	["check"] = "检查",
	["Perform durability check"] = "执行耐久度检查",
	["Check the raid's durability."] = "检查团队耐久度",
	["Name"] = "姓名",
	["Percent"] = "百分比",
	["Broken"] = "损坏",
	["Perc"] = "百分比",
	["Close"] = "关闭",
	["Refresh"] = "刷新",
} end )

L:RegisterTranslations("zhTW", function() return {
	["durabilityleader"] = "durabilityleader",
	["durability"] = "裝備耐久度",
	["Durability"] = "裝備耐久度",
	["Leader/Durability"] = "領隊/裝備耐久度",
	["Options for durability checks."] = "耐久度選項",
	["check"] = "檢查",
	["Perform durability check"] = "執行耐久度檢查",
	["Check the raid's durability."] = "檢查團隊耐久度",
	["Name"] = "姓名",
	["Percent"] = "百分比",
	["Broken"] = "損壞",
	["Perc"] = "百分比",
	["Close"] = "關閉",
	["Refresh"] = "更新",
} end )

L:RegisterTranslations("frFR", function() return {
	--["durabilityleader"] = true,
	--["durability"] = true,
	["Durability"] = "Durabilit\195\169",
	["Leader/Durability"] = "Chef/Durabilit\195\169",
	["Options for durability checks."] = "Options concernant les v\195\169rifications des durabilit\195\169s.",
	--["check"] = true,
	["Perform durability check"] = "V\195\169rifier les durabilit\195\169s",
	["Check the raid's durability."] = "V\195\169rifie les durabilit\195\169s du raid.",
	["Name"] = "Nom",
	["Percent"] = "Pourcent",
	["Broken"] = "Cass\195\169(s)",
	["Perc"] = "Pourc",
	["Close"] = "Fermer",
	["Refresh"] = "Rafra\195\174chir",
} end )

L:RegisterTranslations("deDE", function() return {
	-- ["durabilityleader"] = "",
	-- ["durability"] = "",
	["Durability"] = "Haltbarkeit",
	["Leader/Durability"] = "Anf\195\188hrer/Haltbarkeit",
	["Options for durability checks."] = "Optionen f\195\188r den Haltbarkeits-Check.",
	-- ["check"] = "",
	["Perform durability check"] = "Haltbarkeit \195\156berpr\195\188fen",
	["Check the raid's durability."] = "\195\156berpr\195\188fe die Haltbarkeits-Werte des Schlachtzugs.",
	["Name"] = "Name",
	["Percent"] = "Prozent",
	["Broken"] = "Zerbrochen",
	["Perc"] = "Proz",
	["Close"] = "Schlie\195\159en",
	["Refresh"] = "Erneuern",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule(L["durabilityleader"])
mod.defaults = {}
mod.leader = true
mod.name = L["Leader/Durability"]
mod.consoleCmd = L["durability"]
mod.consoleOptions = {
	type = "group",
	desc = L["Options for durability checks."],
	name = L["Durability"],
	disabled = function() return not oRA:IsActive() end,
	args = {
		[L["check"]] = {
			type="execute", name = L["Perform durability check"],
			desc = L["Check the raid's durability."],
			func = function()
					mod:PerformDurabilityCheck()
				end,
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		},
	}
}


------------------------------
--      Initialization      --
------------------------------

local entry = nil
local durability = {}
local frame = nil
local sorting = {
	L["Name"],
	L["Percent"],
	L["Broken"],
}

function mod:OnEnable()
	self:RegisterCheck("DUR", "oRA_DurabilityResponse")
	self:RegisterShorthand("radur", function(item) self:PerformDurabilityCheck() end )
end

function mod:OnDisable()
	self:UnregisterCheck("DUR")
	self:UnregisterShorthand("radur")

	for k in pairs(durability) do
		durability[k] = nil
	end
end

--------------------
-- Event Handlers --
--------------------

function mod:oRA_DurabilityResponse(msg, author)
	if not self:IsValidRequest(author, true) then return end
	local cur,max,broken,requestby = select(3, msg:find("^DUR (%d+) (%d+) (%d+) ([^%s]+)$"))
	if cur and requestby and requestby == UnitName("player") then
		local p = math.floor(cur / max * 100)
		self:AddPlayer( author, p, broken )
		self:UpdateScrollBar()
	end
end

----------------------
-- Command handlers --
----------------------

function mod:PerformDurabilityCheck()
	if not self:IsPromoted() then return end

	for k in pairs(durability) do
		durability[k] = nil
	end

	self:SendMessage("DURC")

	self:SetupFrames()
	frame:Show()
	self:UpdateScrollBar()
end

-----------------------
-- Utility Functions --
-----------------------

function mod:SetupFrames()
	if frame then return end

	local f = GameFontNormal:GetFont()

	local mf = CreateFrame("Frame", "oRADurReportFrame", UIParent)

	mf:Hide()
	mf:SetWidth(325)
	mf:SetHeight(350)
	mf:EnableMouse(true)
	mf:SetMovable(true)
	mf:RegisterForDrag("LeftButton")
	mf:SetScript("OnDragStart", function() this:StartMoving() end)
	mf:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	mf:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	mf:SetBackdropBorderColor(.5, .5, .5)
	mf:SetBackdropColor(0,0,0)
	mf:ClearAllPoints()
	mf:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	-- File-wide pointer
	frame = mf

	local fade = mf:CreateTexture(nil, "BORDER")
	fade:SetWidth(319)
	fade:SetHeight(25)
	fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	fade:SetPoint("TOP", mf, "TOP", 0, -4)
	fade:SetBlendMode("ADD")
	fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)

	local header = mf:CreateFontString(nil,"OVERLAY")
	header:SetFont(f, 14)
	header:SetWidth(300)
	header:SetText(L["Durability"])
	header:SetTextColor(1, .8, 0)
	header:ClearAllPoints()
	header:SetPoint("TOP", mf, "TOP", 0, -10)

	local headername = CreateFrame("Button", nil, mf)
	headername:SetWidth(150)
	headername:SetHeight(16)
	headername:SetPoint("TOPLEFT", mf, "TOPLEFT", 10, -35)
	headername:SetScript("OnClick", function()
		self:Sort(durability, 1)
		self:UpdateScrollBar()
	end)

	local headernamehigh = headername:CreateTexture(nil, "BORDER")
	headernamehigh:SetWidth(150)
	headernamehigh:SetHeight(16)
	headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headernamehigh:SetAllPoints(headername)
	headernamehigh:SetBlendMode("ADD")
	headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headername:SetHighlightTexture(headernamehigh)

	local headernametext = headername:CreateFontString(nil,"OVERLAY")
	headernametext:SetFont(f, 14)
	headernametext:SetWidth(150)
	headernametext:SetText(L["Name"])
	headernametext:SetTextColor(1, .8, 0)
	headernametext:ClearAllPoints()
	headernametext:SetJustifyH("LEFT")
	headernametext:SetAllPoints(headername)

	local headerperc = CreateFrame("Button", nil, mf)
	headerperc:SetWidth(70)
	headerperc:SetHeight(16)
	headerperc:SetPoint("LEFT", headername, "RIGHT")
	headerperc:SetScript("OnClick", function()
		self:Sort(durability, 2)
		self:UpdateScrollBar()
	end)

	local headerperchigh = headerperc:CreateTexture(nil, "BORDER")
	headerperchigh:SetWidth(70)
	headerperchigh:SetHeight(16)
	headerperchigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headerperchigh:SetAllPoints(headerperc)
	headerperchigh:SetBlendMode("ADD")
	headerperchigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headerperc:SetHighlightTexture(headerperchigh)

	local headerperctext = mf:CreateFontString(nil,"OVERLAY")
	headerperctext:SetFont(f, 14)
	headerperctext:SetWidth(70)
	headerperctext:SetText(L["Perc"])
	headerperctext:SetTextColor(1, .8, 0)
	headerperctext:ClearAllPoints()
	headerperctext:SetJustifyH("LEFT")
	headerperctext:SetAllPoints(headerperc)

	local headerbroken = CreateFrame("Button", nil, mf)
	headerbroken:SetWidth(60)
	headerbroken:SetHeight(16)
	headerbroken:SetPoint("LEFT", headerperc, "RIGHT")
	headerbroken:SetScript("OnClick", function()
		self:Sort(durability, 3)
		self:UpdateScrollBar()
	end)

	local headerbrokenhigh = headerbroken:CreateTexture(nil, "BORDER")
	headerbrokenhigh:SetWidth(60)
	headerbrokenhigh:SetHeight(16)
	headerbrokenhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headerbrokenhigh:SetAllPoints(headerbroken)
	headerbrokenhigh:SetBlendMode("ADD")
	headerbrokenhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headerbroken:SetHighlightTexture(headerbrokenhigh)

	local headerbrokentext = mf:CreateFontString(nil,"OVERLAY")
	headerbrokentext:SetFont(f, 14)
	headerbrokentext:SetWidth(60)
	headerbrokentext:SetText(L["Broken"])
	headerbrokentext:SetTextColor(1, .8, 0)
	headerbrokentext:ClearAllPoints()
	headerbrokentext:SetJustifyH("LEFT")
	headerbrokentext:SetAllPoints(headerbroken)

	local leftbutton = CreateFrame("Button", nil, mf)
	leftbutton:SetWidth(125)
	leftbutton:SetHeight(32)
	leftbutton:SetPoint("BOTTOMRIGHT", mf, "BOTTOM", -10, 10)
	
	local t = leftbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", leftbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	leftbutton:SetNormalTexture(t)

	t = leftbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	leftbutton:SetPushedTexture(t)

	t = leftbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	t:SetBlendMode("ADD")
	leftbutton:SetHighlightTexture(t)

	local leftbuttontext = leftbutton:CreateFontString(nil,"OVERLAY")
	leftbuttontext:SetFontObject(GameFontHighlight)
	leftbuttontext:SetText(L["Refresh"])
	leftbuttontext:SetAllPoints(leftbutton)

	leftbutton:SetScript("OnClick", function()
		self:PerformDurabilityCheck()
	end)

	local rightbutton = CreateFrame("Button", nil, mf)
	rightbutton:SetWidth(125)
	rightbutton:SetHeight(32)
	rightbutton:SetPoint("BOTTOMLEFT", mf, "BOTTOM", 10, 10)

	t = rightbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", rightbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	rightbutton:SetNormalTexture(t)

	t = rightbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	rightbutton:SetPushedTexture(t)

	t = rightbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	t:SetBlendMode("ADD")
	rightbutton:SetHighlightTexture(t)

	local rightbuttontext = rightbutton:CreateFontString(nil,"OVERLAY")
	rightbuttontext:SetFontObject(GameFontHighlight)
	rightbuttontext:SetText(L["Close"])
	rightbuttontext:SetAllPoints(rightbutton)

	rightbutton:SetScript("OnClick", function()
		mf:Hide()
	end)

	entry = {}
	entry[1] = self:ScrollEntryFrame(1)
	entry[1]:SetPoint("TOPLEFT", mf, "TOPLEFT", 10, -55 )
	
	for i = 2, 15 do
		j = i - 1
		entry[i] = self:ScrollEntryFrame()
		entry[i]:SetPoint("TOPLEFT", entry[j], "BOTTOMLEFT")
	end

	local sframe = CreateFrame("ScrollFrame", "oRADurabilityScrollFrame", mf, "FauxScrollFrameTemplate")
	sframe:SetParent(mf)
	sframe:SetWidth(285)
	sframe:SetHeight(240)
	sframe:SetPoint("TOPLEFT", mf, "TOPLEFT", 5, -55)

	local function updateScroll()
		self:UpdateScrollBar()
	end
	sframe:SetScript("OnVerticalScroll", function()
		FauxScrollFrame_OnVerticalScroll(16, updateScroll)
	end)

end

function mod:ScrollEntryFrame()
	local f = CreateFrame("Button", nil, frame)
	f:SetWidth(240)
	f:SetHeight(16)

	local textname = f:CreateFontString(nil,"ARTWORK")
	textname:SetFontObject(GameFontHighlight)
	textname:SetWidth(150)
	textname:SetHeight(16)
	textname:SetJustifyH("LEFT")
	textname:SetNonSpaceWrap(false)
	textname:ClearAllPoints()
	textname:SetPoint( "LEFT", f, "LEFT")
	textname:SetTextColor(1,1,1)
	textname:SetText("Name")

	local textperc = f:CreateFontString(nil,"ARTWORK")
	textperc:SetFontObject(GameFontHighlight)
	textperc:SetWidth(70)
	textperc:SetHeight(16)
	textperc:SetJustifyH("LEFT")
	textperc:SetNonSpaceWrap(false)
	textperc:ClearAllPoints()
	textperc:SetPoint("LEFT", textname, "RIGHT")
	textperc:SetTextColor(1,1,1)
	textperc:SetText("12%")

	local textbroken = f:CreateFontString(nil,"ARTWORK")
	textbroken:SetFontObject(GameFontHighlight)
	textbroken:SetWidth(60)
	textbroken:SetHeight(16)
	textbroken:SetJustifyH("LEFT")
	textbroken:SetNonSpaceWrap(false)
	textbroken:ClearAllPoints()
	textbroken:SetPoint("LEFT", textperc, "RIGHT")
	textbroken:SetTextColor(1,1,1)
	textbroken:SetText("3")

	return f
end

function mod:AddPlayer( nick, perc, broken )
	local update
	for i = 1, 40, 1 do
		if durability[i] and durability[i][1] == nick then
			update = i
		end
	end
	if update then
		durability[update][2] = perc or 0
		durability[update][3] = broken or 0
	else
		table.insert(durability, {nick, perc, broken or 0})
	end
end

local paintchips = nil
local RL = nil
function mod:UpdateScrollBar()
	self:SetupFrames()
	local entries = #durability
	FauxScrollFrame_Update(sframe, entries, 15, 16)

	if not paintchips then paintchips = AceLibrary("PaintChips-2.0") end
	if not RL then RL = AceLibrary("Roster-2.1") end
	for i = 1, 15 do
		local j = i + FauxScrollFrame_GetOffset(sframe)

		if j <= entries then
			local class = RL:GetUnitObjectFromName(durability[j][1]).class
			entry[i].textname:SetText("|cff"..paintchips:GetHex(class)..durability[j][1].."|r")
			entry[i].textperc:SetText(durability[j][2].."%")
			entry[i].textbroken:SetText(durability[j][3])
			entry[i]:Show()
		else
			entry[i]:Hide()
		end
	end

end

function mod:Sort(tbl, sortBy)
	if( sortBy == 2 or sortBy == 1 ) then
		--percent, lowest to highest
		table.sort(tbl,
			function(t1, t2)
				if (t1[sortBy] == t2[sortBy] ) then
					return t1[1] > t2[1]
				else
					return t1[sortBy] < t2[sortBy]
				end
			end
		)
	else
		--broken, highest to lowest
		table.sort(tbl,
			function(t1, t2)
				if (t1[sortBy] == t2[sortBy] ) then
					return t1[1] < t2[1]
				else
					return t1[sortBy] > t2[sortBy]
				end
			end
		)
	end
end

