assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRAPBuff")
local BS = AceLibrary("Babble-Spell-2.2")

local buffs = {
	[BS["Power Word: Fortitude"]] = { 1, 1},
	[BS["Prayer of Fortitude"]] = {1, 2},
	[BS["Mark of the Wild"]] = {2, 1},
	[BS["Gift of the Wild"]] = {2, 2},
	[BS["Arcane Intellect"]] = {3, 1},
	[BS["Arcane Brilliance"]] = {3, 2},
	-- 4 missing from CTRA as well.
	[BS["Shadow Protection"]] = {5, 1},
	[BS["Prayer of Shadow Protection"]] = {5, 2},
	[BS["Power Word: Shield"]] = {6, 0},
	[BS["Soulstone Resurrection"]] = {7, 0},
	[BS["Divine Spirit"]] = {8, 1},
	[BS["Prayer of Spirit"]] = {8, 2},
	[BS["Thorns"]] = {9, 0},
	[BS["Fear Ward"]] = {10, 0},
	[BS["Blessing of Might"]] = {11, 1},
	[BS["Greater Blessing of Might"]] = {11, 2},
	[BS["Blessing of Wisdom"]] = {12, 1},
	[BS["Greater Blessing of Wisdom"]] = {12, 2},
	[BS["Blessing of Kings"]] = {13, 1},
	[BS["Greater Blessing of Kings"]] = {13, 2},
	[BS["Blessing of Salvation"]] = {14, 1},
	[BS["Greater Blessing of Salvation"]] = {14, 2},
	[BS["Blessing of Light"]] = {15, 1},
	[BS["Greater Blessing of Light"]] = {15, 2},
	[BS["Blessing of Sanctuary"]] = {16, 1},
	[BS["Greater Blessing of Sanctuary"]] = {16, 2},
	[BS["Renew"]] = {17, 0},
	[BS["Rejuvenation"]] = {18, 0},
	[BS["Regrowth"]] = {19, 0},
	[BS["Amplify Magic"]] = {20, 0},
	[BS["Dampen Magic"]] = {21, 0},
}

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["buffparticipant"] = true,
	["Participant/Buff"] = true,
	["buff"] = true,
	["Buff"] = true,
	["Options for buffs."] = true,
} end )

L:RegisterTranslations("koKR", function() return {
	["Participant/Buff"] = "부분/버프",
	["Buff"] = "버프",
	["Options for buffs."] = "버프 설정",
} end )

L:RegisterTranslations("zhCN", function() return {
	["buffparticipant"] = "buffparticipant",
	["Participant/Buff"] = "Participant/Buff",
	["buff"] = "buff",
	["Buff"] = "buff",
	["Options for buffs."] = "buff助手选项",
} end )

L:RegisterTranslations("zhTW", function() return {
	["buffparticipant"] = "buffparticipant",
	["Participant/Buff"] = "隊員/增益",
	["buff"] = "增益",
	["Buff"] = "增益",
	["Options for buffs."] = "增益狀態選項",
} end )

L:RegisterTranslations("frFR", function() return {
	["Options for buffs."] = "Options concernant les buffs.",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule(L["buffparticipant"])

mod.participant = true
mod.name = L["Participant/Buff"]

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:RegisterEvent("SpecialEvents_PlayerBuffGained")
	self:RegisterEvent("SpecialEvents_PlayerBuffLost")
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:SpecialEvents_PlayerBuffGained(buff, index)
	if buffs[buff] then
		local timeleft = floor( GetPlayerBuffTimeLeft( index ) + .5 )
		self:SendMessage( "RN " .. timeleft .. " " .. buffs[buff][1] .. " " .. buffs[buff][2] )
	end
end

function mod:SpecialEvents_PlayerBuffLost(buff)
	if buffs[buff] then
		-- we send 1 second left on this buff.
		self:SendMessage( "RN 1 ".. buffs[buff][1] .. " " .. buffs[buff][2] )
	end
end
